﻿module("VOICE")

----------------------------------------------------------------------------------------------------
---------------------------|  V O I C E   T R A N S F O R M   U T I L S  |--------------------------
----------------------------------------------------------------------------------------------------

-----------------------------------------------
-- ASSERT a konyvtari transform fuggvenyekre --
-----------------------------------------------

assert(type(transform_and_format) == "function")
assert(type(transform_pattern_match) == "function")
assert(type(transform_chain) == "function")
assert(type(transform_format_roadnumber_eu) == "function")

local preposition_tbl = {L"через",L"в направлении на"}

local preposition_insert_tbl = {
	{L"в ",{L"переулок",L"проезд",L"тупик"}},
	{L"на ",{L""}},
}

local traffic_preposition_insert_tbl = {
	{L"в ",{L"переулок",L"проезд",L"тупик"}},
	{L"на ",{L""}},
}

local settlement_preposition = L"в направлении на"

local replace_roadnumber = {
	{L"1[PР]%-?92",L"Дорога Калуга Орел"},
	{L"1[PР]%-?119",L"Трасса Орел Тамбов"},
	{L"1[PР]%-?132",L"Дорога Калуга Рязань"},
	{L"1[PР]%-?158",L"Дорога Нижний Новгород Саранск"},
	{L"1[PР]%-?158",L"Дорога Пенза Саратов"},
	{L"1[PР]%-?175",L"Дорога Йошкар-Ола Зеленодольск"},
	{L"1[PР]%-?178",L"Дорога Саранск Ульяновск"},
	{L"1[PР]%-?193",L"Дорога Воронеж Тамбов"},
	{L"1[PР]%-?208",L"Дорога Тамбов Пенза"},
	{L"1[PР]%-?209",L"Дорога Тамбов Пенза"},
	{L"1[PР]%-?228",L"Дорога Сызрань Волгоград"},
	{L"1[PР]%-?241",L"Дорога Казань Ульяновск"},
	{L"1[PР]%-?242",L"Дорога Пермь Екатеринбург"},
	{L"1[PР]%-?253",L"Дорога Майкоп Кореновск"},
	{L"1[PР]%-?335",L"Дорога Оренбург Илек"},
	{L"1[PР]%-?344",L"Дорога Нытва Кудымкар"},
	{L"1[PР]%-?351",L"Дорога Екатеринбург Тюмень"},
	{L"1[PР]%-?354",L"Дорога Екатеринбург Курган"},
	{L"1[PР]%-?402",L"Дорога Тюмень Омск"},
	{L"1[PР]%-?418",L"Дорога Иркутск Усть-Ордынский"},
	{L"1[PР]%-?488",L"Дорога Южно-Сахалинск Корсаков"},
	{L"[AА]%-?100",L"Дорога Москва Бородино"},
	{L"[AА]%-?101",L"Дорога Москва Рославль"},
	{L"[AА]%-?102",L"Рязанское шоссе"},
	{L"[AА]%-?103",L"Щёлковское шоссе"},
	{L"[AА]%-?104",L"Дмитровское шоссе"},
	{L"[AА]%-?105",L"Успенское шоссе"},
	{L"[AА]%-?106",L"Ильинское шоссе"},
	{L"[AА]%-?107",L"Московское малое кольцо"},
	{L"[AА]%-?108",L"Московское большое кольцо"},
	{L"[AА]%-?111",L"Дорога Торжок Осташков"},
	{L"[AА]%-?112",L"Дорога Тверь Ржев"},
	{L"[AА]%-?113",L"Дорога Кострома Иваново"},
	{L"[AА]%-?114",L"Дорога Вологда Новая Ладога"},
	{L"[AА]%-?116",L"Дорога Порхов Остров"},
	{L"[AА]%-?117",L"Дорога Опочка граница с Белоруссией"},
	{L"[AА]%-?121",L"Дорога Санкт-Петербург Ропша"},
	{L"[AА]%-?122",L"Дорога Санкт-Петербург Огоньки"},
	{L"[AА]%-?123",L"Дорога Зеленогорск Выборг"},
	{L"[AА]%-?124",L"Дорога Выборг Приозерск"},
	{L"[AА]%-?125",L"Дорога Молодежное Череасово"},
	{L"[AА]%-?126",L"Дорога Дубки граница с Финляндией"},
	{L"[AА]%-?127",L"Дорога Зверево граница с Финляндией"},
	{L"[AА]%-?128",L"Дорога Санкт-Петербург Морье"},
	{L"[AА]%-?129",L"Дорога Зеленогорск Выборг"},
	{L"[AА]%-?130",L"Дорога Олонец Сортавала"},
	{L"[AА]%-?131",L"Дорога Суоярви Койриноя"},
	{L"[AА]%-?132",L"Дорога Суоярви Юстозеро"},
	{L"[AА]%-?133",L"Дорога Петрозаводск Суоярви"},
	{L"[AА]%-?134",L"Дорога Кочкома Реболы"},
	{L"[AА]%-?135",L"Дорога Кемь Лонка"},
	{L"[AА]%-?136",L"Дорога Лоухи Суоперя"},
	{L"[AА]%-?137",L"Дорога Тунгозеро Калевала"},
	{L"[AА]%-?138",L"Дорога Кола Печенга"},
	{L"[AА]%-?141",L"Дорога Орел Смоленск"},
	{L"[AА]%-?142",L"Дорога Тросна Калиновка"},
	{L"[AА]%-?144",L"Дорога Курск Борисоглебск"},
	{L"[AА]%-?146",L"Дорога Краснодар Новоросийск"},
	{L"[AА]%-?147",L"Дорога Краснодар Джубга"},
	{L"[AА]%-?148",L"Дорога Адлер Красная Поляна"},
	{L"[AА]%-?151",L"Дорога Цивильск Ульяновск"},
	{L"[AА]%-?153",L"Дорога Волгоград Мариновка"},
	{L"[AА]%-?154",L"Дорога Астрахань Ставрополь"},
	{L"[AА]%-?155",L"Дорога Черкесск Домбай"},
	{L"[AА]%-?156",L"Дорога Лермонтов Черкесск"},
	{L"[AА]%-?157",L"Дорога Минеральные Воды Кисловодск"},
	{L"[AА]%-?158",L"Дорога Прохладный Баксан Эльбрус"},
	{L"[AА]%-?166",L"Дорога Чита Забайкальск"},
	{L"[AА]%-?190",L"Дорога Калининград Полесск"},
	{L"[AА]%-?191",L"Дорога Калининград Зеленоградск"},
	{L"[AА]%-?192",L"Дорога Зеленоградск Приморск"},
	{L"[AА]%-?193",L"Дорога Калининград Балтийск"},
	{L"[AА]%-?194",L"Дорога Калининград Мамоново"},
	{L"[AА]%-?195",L"Дорога Калининград Долгоруково"},
	{L"[AА]%-?196",L"Дорога Калининград Крылово"},
	{L"[AА]%-?197",L"Дорога Черняховск Крылово"},
	{L"[AА]%-?198",L"Дорога Советск - Гусев"},
	{L"[AА]%-?212",L"Дорога Псков Изборск"},
	{L"[AА]%-?216",L"Дорога Гвардейск Неман"},
	{L"[AА]%-?229",L"Дорога Калининград Нестеров"},
	{L"[AА]%-?340",L"Дорога Астрахань - Красный Яр"},
	{L"[AА]%-?349",L"Дорога Барнаул Рубцовск"},
	{L"[EЕ]%-?30",L"Минское шоссе"},
	{L"[EЕ]%-?101",L"Шоссе Е 101"},
	{L"[EЕ]%-?105",L"Шоссе Е 105"},
	{L"[EЕ]%-?115",L"Трасса Е 115"},
	{L"[MМ]%-?10",L"Трасса Москва Санкт Петербург"},
	{L"[MМ]%-?11",L"Трасса Санкт Петербург Таллин"},
	{L"[MМ]%-?12",L"Трасса Минск Вильнюс Рига Таллинн"},
	{L"[MМ]%-?13",L"Трасса Брянск Новозыбков"},
	{L"[MМ]%-?14",L"Трасса Брест Кишинев Одесса"},
	{L"[MМ]%-?17",L"Трасса Киев Чоп Будапешт"},
	{L"[MМ]%-?18",L"Трасса Санкт Петербург Мурманск"},
	{L"[MМ]%-?19",L"Трасса Новошахтинск Майский"},
	{L"[MМ]%-?20",L"Трасса Санкт Петербург Минск"},
	{L"[MМ]%-?21",L"Трасса Волгоград Каменск Шахтинский"},
	{L"[MМ]%-?23",L"Трасса Ростов на Дону Таганрог"},
	{L"[MМ]%-?25",L"Трасса Новороссийск Керченский пролив"},
	{L"[MМ]%-?27",L"Трасса Джубга Новороссийск"},
	{L"[MМ]%-?29",L"Трасса Краснодар Баку"},
	{L"[MМ]%-?32",L"Трасса Самара Большая Черниговка"},
	{L"[MМ]%-?36",L"Трасса Челябинск Троицк"},
	{L"[MМ]%-?38",L"Трасса Омск Черлак"},
	{L"[MМ]%-?51",L"Трасса Челябинск Чита"},
	{L"[MМ]%-?52",L"Трасса Новосибирск Бийск"},
	{L"[MМ]%-?53",L"Трасса Челябинск Чита"},
	{L"[MМ]%-?54",L"Трасса Красноярск Кызыл"},
	{L"[MМ]%-?55",L"Трасса Челябинск Чита"},
	{L"[MМ]%-?56",L"Трасса Невр Якутск"},
	{L"[MМ]%-?60",L"Трасса Хабаровск Владивосток"},
	{L"[MМ]%-?1",L"Трасса Москва Минск"},
	{L"[MМ]%-?2",L"Трасса Москва Симферополь"},
	{L"[MМ]%-?3",L"Трасса Москва Киев"},
	{L"[MМ]%-?4",L"Трасса Москва Новороссийск"},
	{L"[MМ]%-?5",L"Трасса Москва Екатеринбург"},
	{L"[MМ]%-?6",L"Трасса Москва Астрахань"},
	{L"[MМ]%-?7",L"Трасса Москва Уфа"},
	{L"[MМ]%-?8",L"Трасса Москва Архангельск"},
	{L"[MМ]%-?9",L"Трасса Москва Рига"},
	{L"[PР]%-?92",L"Дорога Калуга Орел"},
	{L"[PР]%-?111",L"Волоколамское Шоссе"},
	{L"[PР]%-?113",L"Рогачевское Шоссе"},
	{L"[PР]%-?119",L"Дорога Орел Елец Липецк Тамбов"},
	{L"[PР]%-?132",L"Дорога Калуга Тула Рязань"},
	{L"[PР]%-?158",L"Дорога Нижний Новгород Саранск Саратов"},
	{L"[PР]%-?175",L"Дорога Йошкар-Ола Зеленодольск"},
	{L"[PР]%-?178",L"Дорога Саранск Ульяновск"},
	{L"[PР]%-?193",L"Дорога Воронеж Тамбов"},
	{L"[PР]%-?208",L"Дорога Тамбов Пенза"},
	{L"[PР]%-?209",L"Дорога Тамбов Пенза"},
	{L"[PР]%-?228",L"Дорога Сызрань Волгоград"},
	{L"[PР]%-?241",L"Дорога Казань Ульяновск"},
	{L"[PР]%-?242",L"Дорога Пермь Екатеринбург"},
	{L"[PР]%-?253",L"Дорога Майкоп Кореновск"},
	{L"[PР]%-?254",L"Дорога Туапсе Кавказский заповедник"},
	{L"[PР]%-?291",L"Дорога Урвань Уштулу"},
	{L"[PР]%-?297",L"Дорога Владикавказ Беслан"},
	{L"[PР]%-?298",L"Дорога Алагир Нижний Зарамаг"},
	{L"[PР]%-?335",L"Дорога Оренбург Илек"},
	{L"[PР]%-?344",L"Дорога Нытва Кудымкар"},
	{L"[PР]%-?351",L"Дорога Екатеринбург Тюмень"},
	{L"[PР]%-?352",L"Серовский Тракт"},
	{L"[PР]%-?354",L"Дорога Екатеринбург Курган"},
	{L"[PР]%-?402",L"Дорога Тюмень Омск"},
	{L"[PР]%-?404",L"Дорога Тюмень Ханты-Мансийск"},
	{L"[PР]%-?418",L"Дорога Иркутск Усть-Ордынский"},
}

local replace_mapinfo = {
-- там, где заканчивается на точку, нужно добавлять пробел к результирующей строке, т.к. "пр.Декабристов"
	{L"(.*)",L" %1 "},
	{L"Проезб%s+",L"Проезд "},
	{L"Пр%s?-%s?т%s+",L"Проспект "},
	{L"ш%.",L"Шоссе "},
	{L"Ул%.",L"Улица "},
	{L"Туп%.",L"Тупик "},
	{L"Просп%.",L"Проспект "},
	{L"Пр%-д%s+",L"Проезд"},
	{L"Пр%.",L"Проезд "},
	{L"Пл%.",L"Площадь "},
	{L"Пер%.",L"Переулок "},
	{L"Наб%.",L"Набережная "},
	{L"Бул(ьв)?%.",L"Бульвар "},
	{L"Ал%.",L"Аллея "},
	{L"Км%.",L"Километр "},
	{L"Дорога Без Имени",L" "},
	{L"Дор%. Без Имени",L" "},
	{L"Екад%s+",L"Кольцевая Автодорога "},
	{L"Кад%s+",L"Кольцевая Автодорога "},
	{L"Бол.%s",L"Большая "},
	{L"Верхние Поля%s+",L"Верхние полала "},
	{L"Воробьевское%s+",L"Воробьёвское "},
	{L"Влксм%s+",L"Комсомола "},
	{L"Нижние%s+Поля%s+",L"Нижние Полала "},
	{L"Brateyevo%s+",L"Братеево "},
	{L"Domodedowo%s+",L"Домодедово "},
	{L"Dzhubga%s+",L"Джубга "},
	{L"Khimki%s+",L"Химки "},
	{L"Podol'Sk%s+",L"Подольск "},
	{L"Sheremetyevo%s+",L"Шереметьево "},
	{L"Shcherbinka%s+",L"Щербинка "},
	{L"Volokolamsk%s+",L"Волоколамск "},
	{L"St%.",L"Sankt "},
--;**********************************************************************
	{L"(.*)%s+1812[%-%s]Го%s+(.*)",L"%1 восемьсот двенадцатого %2"},
	{L"(.*)%s+1905[%-%s]Го%s+(.*)",L"%1 девятьсот пятого %2"},
	{L"(.*)%s+800[%-%s]Летия%s+(.*)",L"%1 восемьсотлетия %2"},
	{L"(.*)%s+22[%-%s]?Го%s+(.*)",L"%1 двадцать второго %2"},
	{L"(.*)%s+25[%-%s]?Ого%s+(.*)",L"%1 двадцать пятого %2"},
	{L"(.*)%s+26[%-%s]Ти%s+(.*)",L"%1 двадцати шести %2"},
	{L"(.*)%s+10[%-%s]Летия%s+(.*)",L"%1 десятилетия %2"},
	{L"(.*)%s+50[%-%s]Летия%s+(.*)",L"%1 пятидесятилетия %2"},
	{L"(.*)%s+60[%-%s]Летия%s+(.*)",L"%1 шестидесятилетия %2"},

	{L"(.*)%s+10[%-%s]?Ы?й%s+(.*)",L"%1 десятый %2"},
	{L"(.*)%s+11[%-%s]?Ы?й%s+(.*)",L"%1 одиннадцатый %2"},
	{L"(.*)%s+12[%-%s]?Ы?й%s+(.*)",L"%1 двенадцатый %2"},
	{L"(.*)%s+13[%-%s]?Ы?й%s+(.*)",L"%1 тринадцатый %2"},
	{L"(.*)%s+14[%-%s]?Ы?й%s+(.*)",L"%1 четырнадцатый %2"},
	{L"(.*)%s+15[%-%s]?Ы?й%s+(.*)",L"%1 пятнадцатый %2"},
	{L"(.*)%s+16[%-%s]?Ы?й%s+(.*)",L"%1 шестнадцатый %2"},
	{L"(.*)%s+17[%-%s]?Ы?й%s+(.*)",L"%1 семнадцатый %2"},
	{L"(.*)%s+18[%-%s]?Ы?й%s+(.*)",L"%1 восемнадцатый %2"},
	{L"(.*)%s+19[%-%s]?Ы?й%s+(.*)",L"%1 девятнадцатый %2"},

	{L"(.*)%s+10[%-%s]?А?я%s+(.*)",L"%1 десятая %2"},
	{L"(.*)%s+11[%-%s]?А?я%s+(.*)",L"%1 одиннадцатая %2"},
	{L"(.*)%s+12[%-%s]?А?я%s+(.*)",L"%1 двенадцатая %2"},
	{L"(.*)%s+13[%-%s]?А?я%s+(.*)",L"%1 тринадцатая %2"},
	{L"(.*)%s+14[%-%s]?А?я%s+(.*)",L"%1 четырнадцатая %2"},
	{L"(.*)%s+15[%-%s]?А?я%s+(.*)",L"%1 пятнадцатая %2"},
	{L"(.*)%s+16[%-%s]?А?я%s+(.*)",L"%1 шестнадцатая %2"},

	{L"(.*)%s+3[%-%s]?е%s+(.*)",L"%1 третье %2"},
	{L"(.*)%s+1[%-%s]?Го%s+(.*)",L"%1 первого %2"},
	{L"(.*)%s+2[%-%s]?Го%s+(.*)",L"%1 второго %2"},
	{L"(.*)%s+3[%-%s]?Го%s+(.*)",L"%1 третьего %2"},
	{L"(.*)%s+4[%-%s]?Го%s+(.*)",L"%1 четвертого %2"},
	{L"(.*)%s+5[%-%s]?Го%s+(.*)",L"%1 пятого %2"},
	{L"(.*)%s+6[%-%s]?Го%s+(.*)",L"%1 шестого %2"},
	{L"(.*)%s+7[%-%s]?Го%s+(.*)",L"%1 седьмого %2"},
	{L"(.*)%s+8[%-%s]?Го%s+(.*)",L"%1 восьмого %2"},
	{L"(.*)%s+9[%-%s]?Го%s+(.*)",L"%1 девятого %2"},

	{L"(.*)%s+1[%-%s]?Ы?й%s+(.*)",L"%1 первый %2"},
	{L"(.*)%s+2[%-%s]?О?й%s+(.*)",L"%1 второй %2"},
	{L"(.*)%s+3[%-%s]?И?й%s+(.*)",L"%1 третий %2"},
	{L"(.*)%s+4[%-%s]?Ы?й%s+(.*)",L"%1 четвертый %2"},
	{L"(.*)%s+5[%-%s]?Ы?й%s+(.*)",L"%1 пятый %2"},
	{L"(.*)%s+6[%-%s]?О?й%s+(.*)",L"%1 шестой %2"},
	{L"(.*)%s+7[%-%s]?О?й%s+(.*)",L"%1 седьмой %2"},
	{L"(.*)%s+8[%-%s]?О?й%s+(.*)",L"%1 восьмой %2"},
	{L"(.*)%s+9[%-%s]?Ы?й%s+(.*)",L"%1 девятый %2"},

	{L"(.*)%s+1[%-%s]?А?я%s+(.*)",L"%1 первая %2"},
	{L"(.*)%s+2[%-%s]?А?я%s+(.*)",L"%1 вторая %2"},
	{L"(.*)%s+3[%-%s]?Ь?я%s+(.*)",L"%1 третья %2"},
	{L"(.*)%s+4[%-%s]?А?я%s+(.*)",L"%1 четвертая %2"},
	{L"(.*)%s+5[%-%s]?А?я%s+(.*)",L"%1 пятая %2"},
	{L"(.*)%s+6[%-%s]?А?я%s+(.*)",L"%1 шестая %2"},
	{L"(.*)%s+7[%-%s]?А?я%s+(.*)",L"%1 седьмая %2"},
	{L"(.*)%s+8[%-%s]?А?я%s+(.*)",L"%1 восьмая %2"},
	{L"(.*)%s+9[%-%s]?А?я%s+(.*)",L"%1 девятая %2"},
--;**********************************************************************
	{L"%s+м[%.%s]+(.*%s+Улица)%s+",L" Малая %1 "},
	{L"%s+б[%.%s]+(.*%s+Улица)%s+",L" Большая %1 "},
	{L"%s+м[%.%s]+(.*%s+Переулок)%s+",L" Малый %1 "},
	{L"%s+б[%.%s]+(.*%s+Переулок)%s+",L" Большой %1 "},
	{L"%s+м[%.%s]+(.*%s+Тупик)%s+",L" Малый %1 "},
	{L"%s+б[%.%s]+(.*%s+Тупик)%s+",L" Большой %1 "},
	{L"%s+м[%.%s]+(.*%s+Проезд)%s+",L" Малый %1 "},
	{L"%s+б[%.%s]+(.*%s+Проезд)%s+",L" Большой %1 "},
	{L"%s+в[%.%s]+(.*%s+Улица)%s+",L" Верхняя %1 "},
	{L"%s+н[%.%s]+(.*%s+Улица)%s+",L" Нижняя %1 "},
	{L"%s+в[%.%s]+(.*%s+Переулок)%s+",L" Верхний %1 "},
	{L"%s+н[%.%s]+(.*%s+Переулок)%s+",L" Нижний %1 "},
	{L"%s+в[%.%s]+(.*%s+Проезд)%s+",L" Верхний %1 "},
	{L"%s+н[%.%s]+(.*%s+Проезд)%s+",L" Нижний %1 "},

--;**********************************************************************
--	{L"(.*)%s+Набережная%s+(.*)",L"%1 %2 Набережная "},
--	{L"(.*)%s+Улица%s+(.*)",L"%1 %2 Улица "},
--	{L"(.*)%s+Площадь%s+(.*)",L"%1 %2 Площадь "},
--	{L"(.*)%s+Переулок%s+(.*)",L"%1 %2 Переулок "},
--	{L"(.*)%s+Проезд%s+(.*)",L"%1 %2 Проезд "},
--	{L"(.*)%s+Тупик%s+(.*)",L"%1 %2 Тупик "},
--	{L"(.*)%s+Проспект%s+(.*)",L"%1 %2 Проспект "},
--	{L"(.*)%s+Бульвар%s+(.*)",L"%1 %2 Бульвар "},
--	{L"(.*)%s+Шоссе%s+(.*)",L"%1 %2 Шоссе "},
--	{L"(.*)%s+Трасса%s+(.*)",L"%1 %2 Трасса "},

	{L"^(%u)(%u)[ -]*(%d+)",L"%1.%2. %3"},
	{L"%-",L" "},
	{L"(%d)(%a)",L"%1 %2"},
	{L"(%a)(%d)",L"%1 %2"},
	{L"//",L", "},
	{L"%s+",L" "},
	{L"^%s",L""},
	{L"%s$",L""},
}

local replace_for_turns = {
	{L"(.*)",L" %1 "},

--; здесь падежи для поворотов "на..."

	{L"(.*)%s+Улица%s+",L" Улицу %1"},
	{L"(.*)%s+Площадь%s+",L" Площадь %1"},
	{L"(.*)%s+Переулок%s+",L" Переулок %1"},
	{L"(.*)%s+Проспект%s+",L" Проспект %1"},
	{L"(.*)%s+Проезд%s+",L" Проезд %1"},
	{L"(.*)%s+Тупик%s+",L" Тупик %1"},
	{L"(.*)%s+Бульвар%s+",L" Бульвар %1"},
	{L"(.*)%s+Шоссе%s+",L" Шоссе %1"},
	{L"(.*)%s+Трасса%s+",L" Трассу %1"},
	{L"(.*)%s+Линия%s+",L" Линию %1"},
	{L"(.*)%s+Аллея%s+",L" Аллею %1"},
	{L"(.*)%s+Набережная%s+",L" Набережную %1"},
	{L"%s+Кольцевая Автодорога%s+",L" Кольцевую Автодорогу "},
--;**********************************************************************
	{L"%s+",L" "},
	{L"^%s",L""},
	{L"%s$",L""},
}

local accusative_case = {
	{L"(.*)",L" %1 "},
	--; изменение порядка
	{L"%s+(Улицу)%s+(.*)яя%s+",L"%2юю %1 "},
	{L"%s+(Набережную)%s+(.*)яя%s+",L"%2юю %1 "},
	{L"%s+(Площадь)%s+(.*)яя%s+",L"%2юю %1 "},
	{L"%s+(Аллею)%s+(.*)яя%s+",L"%2юю %1 "},
	{L"%s+(Дорогу)%s+(.*)яя%s+",L"%2юю %1 "},
	-- {L"(улицу|набережную|площадь|аллею|дорогу)%s(.*)яя",L"%2юю %1"},
	{L"%s+(Улицу)%s+(.*)ая%s+",L"%2ую %1 "},
	{L"%s+(Набережную)%s+(.*)ая%s+",L"%2ую %1 "},
	{L"%s+(Площадь)%s+(.*)ая%s+",L"%2ую %1 "},
	{L"%s+(Аллею)%s+(.*)ая%s+",L"%2ую %1 "},
	{L"%s+(Дорогу)%s+(.*)ая%s+",L"%2ую %1 "},
	-- {L"(улицу|набережную|площадь|аллею|дорогу)%s(.*)ая",L"%2ую %1"},
	{L"%s+(Проспект)%s+(.*)ий%s+",L"%2ий %1 "},
	{L"%s+(Бульвар)%s+(.*)ий%s+",L"%2ий %1 "},
	{L"%s+(Проезд)%s+(.*)ий%s+",L"%2ий %1 "},
	{L"%s+(Тупик)%s+(.*)ий%s+",L"%2ий %1 "},
	{L"%s+(Переулок)%s+(.*)ий%s+",L"%2ий %1 "},
	-- {L"(проспект|бульвар|проезд|тупик|переулок) (.*)ий",L"%2ий %1"},
	{L"%s+(Проспект)%s+(.*)ый%s+",L"%2ый %1 "},
	{L"%s+(Бульвар)%s+(.*)ый%s+",L"%2ый %1 "},
	{L"%s+(Проезд)%s+(.*)ый%s+",L"%2ый %1 "},
	{L"%s+(Тупик)%s+(.*)ый%s+",L"%2ый %1 "},
	{L"%s+(Переулок)%s+(.*)ый%s+",L"%2ый %1 "},
	-- {L"(проспект|бульвар|проезд|тупик|переулок) (.*)ый",L"%2ый %1"},
	{L"%s+(Шоссе)%s+(.*)ое%s+",L"%2ое %1 "},

--; коррекция ошибок предыдущего преобразования
	{L"Миклухо-Маклую%s+(.*)",L"%1 Миклухо-Маклая "},

	{L"%s+",L" "},
	{L"^%s",L""},
	{L"%s$",L""},

}

local replace_sentence={
	{L"\. *[Dd]ann",L", dann"},
	{L"(%p)+ *(%p)+",L"%1 "},
	{L"%s+(%p+)",L"%1 "},
	{L" +",L" "},
}

local function get_preposition(str, tbl)
	str = wstring.lower(str)
	for k,value in ipairs(tbl) do
		for _,pattern in ipairs(tbl[k][2]) do
			if wstring.find(str,pattern) then
				return tbl[k][1]
			end
		end
	end
end

----------------------------------------------------------------------------------------------------
----------------------------------------|  G U I D A N C E  |---------------------------------------
----------------------------------------------------------------------------------------------------

local function not_settlement(str)
	str = wstring.lower(str)
	if transform_pattern_match(str,preposition_tbl) then
		return L""
	end
        return get_preposition(str, preposition_insert_tbl)
end

local function signpost_exitnumber(data, idx)
	local exitnumber = data[idx].signpost.exitnumber
	if exitnumber then
		return not_settlement(exitnumber.text) .. transform_and_format(exitnumber,replace_mapinfo)
	end
end

local function signpost_exitname(data, idx)
	local exitname = data[idx].signpost.exitname
	if exitname then
--		return not_settlement(exitname.text) .. transform_and_format(exitname,replace_mapinfo)
		local str=smart_lower_case(exitname.text)
		voice_debug_log(L"TTS: signpost_exitname in: "..str, 3)
		local str1=nil
		if exitname.phoneme then str1=transform_and_format(exitname,replace_mapinfo)
		else
			str1 = transform_and_format(str,replace_mapinfo)
			str1 = transform_and_format(str1,replace_for_turns)
			if sc_GetSysEntry("tts", "accusative_case", 0) then str1 = transform_and_format(str1,accusative_case)
			end
		end
		str1=not_settlement(str) .. str1
		voice_debug_log(L"TTS: signpost_exitname out: "..str1, 3)
		return str1
	end
end

local function signpost_destination(data, idx)
	local dest = data[idx].signpost.destination
	if dest then
--		return not_settlement(dest.text) .. transform_and_format(dest,replace_mapinfo)
		local str=smart_lower_case(dest.text)
		local str1=nil
		if dest.phoneme then str1=transform_and_format(dest,replace_mapinfo)
		else
			voice_debug_log(L"TTS: signpost_destination in: "..str, 3)
			str1 = transform_and_format(str,replace_mapinfo)
			str1 = transform_and_format(str1,replace_for_turns)
			if sc_GetSysEntry("tts", "accusative_case", 0) then str1 = transform_and_format(str1,accusative_case)
			end
		end
		str1=not_settlement(str) .. str1
		voice_debug_log(L"TTS: signpost_destination out: "..str1, 3)
		return str1
	end
end

local function signpost_settlement(data, idx) 			--  в "напрвлении" где символы  '>>'
	local settlement = data[idx].signpost.settlement
	if settlement then
--		local str = transform_and_format(settlement,replace_mapinfo)
		local str=smart_lower_case(settlement.text)
		local str1=nil
		if settlement.phoneme then str1=transform_and_format(settlement,replace_mapinfo)
		else
			voice_debug_log(L"TTS: signpost_settlement in: "..str, 3)
			str1 = transform_and_format(str,replace_mapinfo)
			str1 = transform_and_format(str1,replace_for_turns)
			if sc_GetSysEntry("tts", "accusative_case", 0) then str1 = transform_and_format(str1,accusative_case)
			end
		end
		-- Ha van benn gyarilag "richtung"
		if not wstring.find(str1,settlement_preposition) then
			str1=settlement_preposition .. L" " .. str1
		end
		voice_debug_log(L"TTS: signpost_settlement out: "..str1, 3)
		return str1
	end
end

local function signpost_roadnumber(data, idx)    		--  название трассы M1 ... Mx
	-- Road numberhez nem hasznaljuk a fonemat
	local roadnumber = data[idx].signpost.roadnumber
	if roadnumber then
--		return not_settlement(roadnumber.text) .. transform_format_roadnumber_eu(roadnumber.text)
		local str=roadnumber.text
		voice_debug_log(L"TTS: signpost_roadnumber in: "..str, 3)
		local str1=transform_and_format(roadnumber.text,replace_roadnumber)
		voice_debug_log(L"TTS: signpost_number middle: "..str1, 3)
		str1=transform_and_format(str1,replace_for_turns)
		str1=not_settlement(str) .. str1
		voice_debug_log(L"TTS: signpost_roadnumber out: "..str1, 3)
		return str1
	end
end

local function road_name(data, idx)				--  название дороги
	local name = data[idx].road.name
	if name then
--	return not_settlement(name.text) .. transform_and_format(name,replace_mapinfo)
		local str=smart_lower_case(name.text)
		voice_debug_log(L"TTS: road_name in: "..str, 3)
		local str1=nil
		if name.phoneme then str1=transform_and_format(name,replace_mapinfo)
		else
			str1 = transform_and_format(str,replace_mapinfo)
			str1 = transform_and_format(str1,replace_for_turns)
			if sc_GetSysEntry("tts", "accusative_case", 0) then str1 = transform_and_format(str1,accusative_case)
			end
		end
		str1=not_settlement(str) .. str1
		voice_debug_log(L"TTS: road_name out: "..str1, 3)
		return str1
	end
end

local function road_number(data, idx)    		--  название дорог Е101 ...
	local number = data[idx].road.number
	if number then
--		return not_settlement(number.text) .. transform_format_roadnumber_eu(number.text)
		local str=number.text
		voice_debug_log(L"TTS: road_number in: "..str, 3)
		local str1=transform_and_format(number.text,replace_roadnumber)
		voice_debug_log(L"TTS: road_number middle: "..str1, 3)
		str1=transform_and_format(str1,replace_for_turns)
		str1=not_settlement(str) .. str1
		voice_debug_log(L"TTS: road_number out: "..str1, 3)
		return str1
	end
end

function format_destname(data, idx)
	local t
	if data[idx].signpost then
		t = transform_chain({}, signpost_exitname, 	data, idx)
		t = transform_chain(t,  signpost_exitnumber, data, idx)
		t = transform_chain(t,  signpost_roadnumber,data, idx)
		t = transform_chain(t,  signpost_destination,	data, idx)
		t = transform_chain(t,  signpost_settlement, 	data, idx)
	elseif data[idx].road then
		t = transform_chain({}, road_number, 	data, idx)
		t = transform_chain(t,  road_name, 	data, idx)
	end
	return table_concat(t, L", ")
end

function format_streetname(data, idx)
	local t
	t = transform_chain({}, road_number, 	data, idx)
	t = transform_chain(t,  road_name, 	data, idx)
	return table_concat(t, L", ")
end

function format_sentence(str)
	for key, value in ipairs(replace_sentence) do
		str = wstring.gsub(str,value[1],value[2])
	end
	return str
end


----------------------------------------------------------------------------------------------------
-----------------------------------|  R O U T E   S U M M A R Y  |----------------------------------
----------------------------------------------------------------------------------------------------

function route_summary_format_road_name(data)
	if data.phoneme then return data.phoneme
	else  -- return transform_format_roadnumber_eu(data.text)
		return transform_and_format(data.text,replace_roadnumber)
	end
end

function route_summary_format_street_name(data)
	if data.phoneme then return data.phoneme
	else 	-- return data.text
		local str=smart_lower_case(data.text)
		return transform_and_format(str,replace_mapinfo)
	end
end

function route_summary_format_bridge_tunnel(data)
	if data.phoneme then return data.phoneme
	else return data.text
	end
end

function route_summary_format_order(data)
	if data.phoneme then return data.phoneme
	else return data.text
	end
end

----------------------------------------------------------------------------------------------------
-----------------------------------------|  T R A F F I C  |----------------------------------------
----------------------------------------------------------------------------------------------------

-- 1. Zar az M0 uton, Martonvasar kozeleben. = in die Strasse Numer A1, in der Nähe von Martonvasar./ in der Nähe von der HaupStrasse Numer 33.
-- 2. Zar az M0 uton, Martonvasar es Velence kozt. = in die Strasse Numer A1, zwischen Martonvasar und Velence.
-- 3. Zar a Budai uton, a Budai ut Fiskalis ut keresztezodesben = in der/dem (lsd tabla) Budai ut, in der Kreuzung Budai ut und Fiskalis ut.
-- 4. Zar a Budai uton, Fiskalis ut es 8. ut kozott. = in der/dem Budai ut, zwischen Fiskalis ut und 8. ut.

function traffic_event_supported()
	return true
end

function traffic_event(DescKey, data)
	local str = translate_voice(DescKey)
	local loc = MODEL.regional.is_it_voice_localizable(DescKey)
	ASSERT(loc, "Missing TrafficEvent dictionary.voice key:" .. DescKey)
	---- Roadnumber prioritas
	if data.roadnumber then
		local road = L" in die Strasse Numer "..transform_format_roadnumber_eu(data.roadnumber.text)
		if data.from and not data.to then
		-- M7 uton Martonvasar kozeleben
			str =  str..road..L", in der Nähe von "..transform_and_format(data.from)
		elseif data.from and data.to then
		-- M7 uton, Martonvasar es Velence kozott
			str =  str..road..L", zwischen "..transform_and_format(data.from)..L" und "..transform_and_format(data.to)
		else
		-- Egyeb: M7 uton
			str = str..road
		end
	---- Roadname
	elseif data.roadname then
		-- Text/fonema + prepocicio
		local road = transform_and_format(data.roadname)
		road = L" in"..get_preposition(data.roadname.text, traffic_preposition_insert_tbl)..road
		if data.from and not data.to then
			-- "," menten robbantunk
			local _,_, from, to = wstring.find(data.from.text, L"^([^,]+),(.+)$")
			if from and to then
				str = str..road..L", in der Kreuzung "..from..L" und "..to
			else
				str = str..road..L", in der Kreuzung "..data.from.text
			end
		elseif data.from and data.to then
			str = str..road..L", zwischen "..transform_and_format(data.from)..L" und "..transform_and_format(data.to)
		else
			str = str..road
		end
	---- Nincs se roadnumber, se roadname
	else
		if data.from and not data.to then
		-- Martonvasar kozeleben
			str =  str..L" in der Nähe von "..transform_and_format(data.from)
		elseif data.from and data.to then
		-- Martonvasar es Velence kozott
			str =  str..L" zwischen "..transform_and_format(data.from)..L" und "..transform_and_format(data.to)
		else
		-- Egyeb: semmi
		end
	end
	str = str..L"."
	return str
end

--function smart_lower_case_inner(str1, str2)
--	return str1..wstring.upper(wstring.sub(str2, 1, 1))..wstring.lower(wstring.sub(str2, 2))
--end
function smart_lower_case_inner2(str1, str2, str3)
	return str1..wstring.lower(str2)..str3
end
--function smart_lower_case_inner3(str)
--	return wstring.upper(wstring.sub(str, 1, 1))..wstring.lower(wstring.sub(str, 2))
--end
--function smart_lower_case_inner4(str1, str2)
--	return wstring.lower(str1)..str2
--end
function smart_lower_case_inner5(str)
	return wstring.upper(wstring.sub(str, 1, 1))..wstring.lower(wstring.sub(str, 2))
end
function smart_lower_case(str)
--	voice_debug_log(L"TTS:smart_lower_case_in: "..str, 3)
	local str1=wstring.gsub(L" "..str..L" ", L"(%A)(%u)(%A)", smart_lower_case_inner2)
	str1=wstring.gsub(str1, L"(%a%a+)", smart_lower_case_inner5)
	voice_debug_log(L"TTS:smart_lower_case_out: "..str1, 3)
	return str1
end	
--function smart_lower_case(str)
--	local str1=wstring.gsub(str, L"(%A)(%u)(%A)", smart_lower_case_inner2) -- one symbol to lowercase
--	str1=wstring.sub(str1, 1, wstring.len(str1)-1)..wstring.lower(wstring.sub(str1, wstring.len(str1))) -- last symbol to lowercase
--	str1=wstring.gsub(str1, L"^(%a%a+)", smart_lower_case_inner3)	-- first word
--	str1=wstring.gsub(str1, L"^(%u)(%A)", smart_lower_case_inner4)	-- first single symbol to lowercase
--	return wstring.gsub(str1, L"(%A)(%a%a+)", smart_lower_case_inner)
--end
--function smart_lower_case(str)
--	local str1=wstring.gsub(str, L"([%s%p%d%-])(%u)([%s%p%d%-])", smart_lower_case_inner2) -- one symbol to lowercase
--	str1=wstring.sub(str1, 1, wstring.len(str1)-1)..wstring.lower(wstring.sub(str1, wstring.len(str1))) -- last symbol to lowercase
--	str1=wstring.gsub(str1, L"^(%a%a+)", smart_lower_case_inner3)	-- first word
--	str1=wstring.gsub(str1, L"^(%u)([%s%p%d-])", smart_lower_case_inner4)	-- first single symbol to lowercase
--	return wstring.gsub(str1, L"([%s%p%d%-])(%a%a+)", smart_lower_case_inner)
--end
